;
; FILE REQUEST.ASM 
;
; COPYRIGHT 1980, 1981, 1982, 1983 CONVERGENT TECHNOLOGIES,INC.
; ALL RIGHTS RESERVED
;
; THIS PROGRAM IS FURNISHED UNDER A LICENSE RESTRICTING ITS USE
; SOLELY FOR THE OPERATION OF A DESIGNATED COMPUTER FOR A
; PARTICULAR PURPOSE,AND MAY NOT BE COPIED OR OTHERWISE USED
; WITHOUT THE PRIOR WRITTEN CONSENT OF CONVERGENT TECHNOLOGIES,
; INC.  TITLE TO AND OWNERSHIP OF THE PROGRAM, INCLUDING ITS
; SOURCE CODE, SHALL AT ALL TIMES REMAIN IN CONVERGENT
; TECHNOLOGIES.
;
;
; NOTES FOR CHANGING THIS FILE 
;
; Please be aware that in the Convergent Assembly language
; there are two types of comments: normal comments (any text on
; a line after a ; character, and a macro comment (' text ').
; It is not possible to comment out a macro by inserting a
; ; in front of it.  You may comment out a macro by replacing
; the percent sign in the call with a ;, or by precceding the
; call with '.  This will cause the macro processor to
; ignore any text up to and including the next ' or RETURN
; (0Ah) character,whichever comes first.
;
; Macro calls must not be mixed.  In general,the invocation of
; a macro causes an entry to be added to a table,and mixing
; macro calls would result in scrambled tables.
;

$INCLUDE (request.mdf)

;
; The next set of macros construct 6 tables which are used by
; Convergent to implement OS service request.  When a new
; request code is added to the OS,a new entry has to be added
; using the macro SysRequest.  Request codes have to be
; within 0  4063 (0FDFh) and contiguous.  The requestNumber
; field is used by the macro just to verify the coniguousness
; of the requests.  Although a system builder may replace a
; SysRequest definition with one of their own,  adding new
; SysRequest's is not allowed, as this may conflict with
; future Convergent requests.  New requests should be added
; using the UsrRequest declarations which follow the
; SysRequest's.
;
;
' SYSREQUEST MACRO DEFINITION 
'
'  MACRO FORMAT 
'	The SysRequest macro takes 9 arguments which are
' described below.  The first 7 arguments must be on the same
' line, and the last two arguments, the parameter format
' and the net routing code, can be on
' additional lines.  A full description of the fields of the
' macro and their use can be found in the CTOS manual and in
' the System Programmers Guide.  The macro arguments are
' defined as follows:
'
'   SysRequest(
'	 rqCode ....... The request number of the service
'			interface.  These numbers must be in
'			order with no omissions.
'	,name ......... The name of the procedure.  This field
'			is here for convenience only and is not
'			used internally by the macro.
'	,exchange ..... This is the CTOS exchange that the
'			request will be routed to by the
'			Request interface.
'	,ServiceCode .. This field is for the convenience of
'			the Service process, and can be used in
'			any way the process desires.
'	,sCntInfo .....
'	,nReqPbCb .....
'	,nRespPbCb .... These values are put into the request
'			block which the CTOS procedural
'			interface creates for the user in the
'			fields of the same name.
'	, ( format ) . The format is described in the
'			following section.
'	, ( netRouting ) . The netRouting is described in the
'			following section.
'	)
'
' FORMAT 
'	The format is a set of short macros which define the
' order and type of arguments that are pushed onto the stack
' when a user calls the CTOS procedural interface.  Also in
' the format are any constants which go into the request
' block.  The CTOS procedural initializes the request block to
' zeros, so any zero constants may be omitted.  The macros are
' defined as follows:
'
'  name:           meaning:
'	illegal ...... call to this request is an error.
'	none ......... no arguments on stack (this call is
'			optional).
'	c(v,o) ....... byte value v is placed in request
'			block at offset o in the request
'			block.
'	w(o) ......... the next word on the stack goes at
'			offset o.
'	b(o) ......... the low byte of next word on stack goes
'			 at offset o
'
' For convenience, the following abbreviations are also defined:
'
'  abbreviation:  definition:
'	fh .......... w(12)
'	lfa ......... w(16) w(14)
'	p(o) ........ w(o+2) w(o)
'	pbCb0 ....... w(20) w(18) w(22)
'	p0 .......... w(20) w(18)
'	s0 .......... w(22)
'	pbCb1 ....... w(26) w(24) w(28)
'	p1 .......... w(26) w(24)
'	s1 .......... w(28)
'	pbCb2 ....... w(32) w(30) w(34)
'	p2 .......... w(32) w(30)
'	s2 .......... w(34)
'	p3 .......... w(38) w(36)
'	pbCb3 ....... w(38) w(36) w(40)
'
' NET ROUTING 
' The table rgNetRouting is used by the CTOS Kernel to decide whether a
' request gets routed by file handle, by file spec, or not at all.
' It is also used by the Agent to determine how to expand file specs.
' The following is a set of general rules for request blocks that have
' file specs. These rules permit routing information to be encoded.
'
'	1. A request may not have more than two file specs.
'	2. The first file spec must be specified by the first pbcb pair.
'	3. If a file spec has a password, it must be specified by the pbcb
'		pair that immediately follows the pbcb for the file spec.
'	4. If one file spec has a password associated with it, then
'		all file specs in the request must have passwords.
'
'	RW  This request is a read or write and may have to be
'		 be broken up in to smaller requests.
'	    SpecPW  All file spec pbcb pairs are followed by password pbcb pairs.
'	rFh          Route this request by the file handle.
'	openFh       This request opens a resource that owns a file handle
'	             and returns the handle in the first response pbcb pair.
'	closeFh      This request closes a resource that owns a file handle.
'	DevSpec      Route this request by dev spec
'	DirSpec      Route this request by dir Spec
'	FileSpec     Route this request by file spec
'	FileSpec2    Route this request by file spec (request contains 2 of them)
'	FileSpecP2S2 Route by file spec in p2s2
;
;
; Exchange definitions 
;	Exchanges 0 to 20 are reserved for CTOS processes.
;
; Virtual exchanges, replaced at boot time;
;  translation table created in Sysgen.Mdf,
;  varies with CTOS version.
    exchAgent	EQU  1
    exchNotInstalled EQU  2
    exchMassIO	EQU  3		; Mass storage IO manager
    exchFilSys1	EQU  4		; File system manager Utility
    exchFilSys2	EQU  5
    exchFilSys3	EQU  6
    exchFilSys4	EQU  7
    exchChgUsrN	EQU  8		; MultiPart Change User Num Rq for FS
    exchSrpAgent EQU 9
    exchLog	EQU  10
	exchFilterPros EQU 11
	exchMem	EQU 12
	exchVp	EQU 13		; VarPart only rqs
    exchKbd	EQU 14		; Keyboard manager Debugger, maybe resident
	exchResex EQU 15	; overlay manager
	exchRemoteTerm	EQU 16
;
; Exchanges constant over all versions of CTOS,
;  or equated to virtual exchanges.
	exchMaster	EQU  exchNotInstalled	; Service from master, if exists
    exchISAM	EQU  exchNotInstalled	; ISAM service
    exchDBMS	EQU  exchNotInstalled	; DBMS service
    exch3270	EQU  exchNotInstalled	; 3270
    exchKbdRes	EQU  1		; Keyboard manager Debugger, resident portion
    exchSysIn	EQU  3		; System Input proccess
    exchTerm	EQU  5		; Application terminator
;    exchLclFs	EQU 10		; File system manager Utility
    exchSplr	EQU  0		; Print Spooler
    exchSplrOld	EQU  exchNotInstalled	; Print Spooler
    exchQueMgr	EQU  exchNotInstalled   ; Queue Manager
    exchRJE	EQU  exchNotInstalled   ; RJE
    exchTask	EQU exchResex
    exchVideo	EQU 0		; No video until Vdm_xx.run.
	exchCommLine	EQU exchResex
    exchCommSer	EQU exchNotInstalled
    exchTape	EQU exchNotInstalled	; Tape Server
    exchX25	EQU exchNotInstalled	; X.25
    exchSNA     EQU exchNotInstalled	; SNA
    exchMailSer EQU exchNotInstalled	; Mail Server
	exchSched	EQU exchVp
	exchUser	EQU exchMem			; userNum creationdeletion
	exchNotPresent EQU 0	; not installed, don't try master

'	SYSREQUEST ENTRIES MUST COME FIRST

SysRequestInit

SysRequest(0,(illegal),0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(1,SetPath,exchResex,0D13h,6,3,0,
		( pbcb0 pbcb1 pbcb2 ),
		( noRouting ))

SysRequest(2,ClearPath,exchResex,0D14h,0,0,0,
		( none ),
		( noRouting ))

SysRequest(3,SetPrefix,exchResex,0D15h,6,1,0,
		( pbcb0 ),
		( noRouting ))

SysRequest(4,OpenFile,exchFilSys1,0001h,6,2,1,
		( c(2,34) p2 pbcb0 pbcb1 w(14) ),
		( FileSpec SpecPW openFh CloseAtTermination))

SysRequest(5,CreateFile,exchFilSys1,0000h,6,2,0,
		( pbcb0 pbcb1 lfa ),
		( FileSpec SpecPW ))

SysRequest(6,DeleteFile,exchFilSys1,000Ch,2,0,0,
		( fh ),
		( rFh closeFh ))

SysRequest(7,RenameFile,exchFilSys1,0002h,6,2,0,
		( fh pbcb0 pbcb1 ),
		( rFh FileSpec SpecPW ))

SysRequest(8,GetFileStatus,exchFilSys1,0700h,6,0,1,
		( fh w(14) pbcb0 ),
		( rFh ))

SysRequest(9,SetFileStatus,exchFilSys1,0701h,6,1,0,
		( fh w(14) pbcb0 ),
		( rFh ))

SysRequest(10,CloseFile,exchFilSys1,000Bh,2,0,0,
		( fh ),
		( rFh closeFh))

SysRequest(11,MountVolume,exchFilSys1,0800h,6,2,0,
		( pbcb0 pbcb1 ),
		( DevSpec SpecPW ))

SysRequest(12,DismountVolume,exchFilSys1,0801h,6,2,0,
		( pbcb0 pbcb1 ),
		( DevSpec SpecPW ))

SysRequest(13,ChangeFileLength,exchFilSys1,0009h,6,0,0,
		( fh lfa ),
		( rFh ))

SysRequest(14,GetDateTime,exchFilSys3,0200h,6,0,1,
		( p0 c(4,22) ),
		( noRouting ))

SysRequest(15,GetVhb,exchFilSys1,0803h,6,1,1,
		( pbcb0 pbcb1 ),
		( DevSpec ))

SysRequest(16,SetDevParams,exchFilSys1,0804h,6,2,0,
		( pbcb0 pbcb1 w(12) ),
		( DevSpec SpecPW ))

SysRequest(17,CreateDir,exchFilSys1,0003h,6,3,0,
		( pbcb0 pbcb1 pbcb2 w(14) w(16) ),
		( DirSpec SpecPW ))

SysRequest(18,DeleteDir,exchFilSys1,0004h,6,2,0,
		( pbcb0 pbcb1 ),
		( DirSpec SpecPW ))

SysRequest(19,CloseAllFiles,exchFilSys3,000Dh,0,0,0,
		( none ),
		( noRouting ))

SysRequest(20,QuietIO,exchFilSys3,0012h,0,0,0,
		( none ),
		( noRouting ))

SysRequest(21,QueryVidHdw,exchVideo,0C03h,6,0,1,
		( pbcb0 ),
		( noRouting ))

SysRequest(22,LoadFontRam,exchVideo,0B00h,6,1,0,
		( fh pbcb0 ),
		( noRouting ))

SysRequest(23,LoadStyleRam,exchVideo,0B03h,6,1,0,
		( pbcb0 ),
		( noRouting ))

SysRequest(24,LoadCursorRam,exchVideo,0B02h,6,1,0,
		( pbcb0 ),
		( noRouting ))

SysRequest(25,ReadDirSector,exchFilSys1,0005h,6,2,1,
		( pbcb0 pbcb1 w(14) p2 c(2,35) ),
		( DirSpec SpecPW ))  ; *1

SysRequest(26,GetDcbOld,exchFilSys1,0805h,6,2,1,
		( pbcb0 pbcb1 pbcb2),
		( DevSpec ))

SysRequest(27,GetUcb,exchResex,0D17h,6,0,1,
		( pbcb0 ),
		( noRouting ))

SysRequest(28,Chain,exchTerm,0101h,6,2,0,
		( pbcb0 pbcb1 w(12) w(14) w(16) ),
		( noRouting ))

SysRequest(29,LoadTask,exchTerm,0004h,6,0,0,
		( fh w(14) w(16) ),
		( noRouting ))

SysRequest(30,SetFhLongevity,exchFilSys1,0011h,4,0,0,
		( w(12) w(14) ),
		( rFh ))

SysRequest(31,GetFhLongevity,exchFilSys1,0010h,6,0,1,
		( fh p0 c(1,22) ),
		( rFh ))

SysRequest(32,ResetSubsys,exchTask,0E00h,6,0,0,
		( fh w(14) w(16) ),
		( noRouting ))

SysRequest(33,DeviceRead,exchMassIo,8000h,6,0,2,
		( w(12) pbcb0 lfa p1 c(2,28) ),
		( RW ))

SysRequest(34,DeviceWrite,exchMassIo,8001h,6,1,1,
		( w(12) pbcb0 lfa p1 c(2,28) ),
		( RW ))

SysRequest(35,Read,exchFilSys2,0000h,6,0,2,
		( fh pbcb0 lfa p1 c(2,28) ),
		( rFh RW ))

SysRequest(36,Write,exchFilSys2,0001h,6,1,1,
		( fh pbcb0 lfa p1 c(2,28) ),
		( rFh RW ))

SysRequest(37,DeviceReadIdAndData,exchMassIo,8002h,6,0,2,
		( w(12) pbcb0 lfa p1 c(2,28) ),
		( noRouting ))

SysRequest(38,Format,exchFilSys2,0003h,6,1,1,
		( w(12) pbcb0 lfa p1 c(2,28) ),
		( rFh RW ))

SysRequest(39,DeviceReadID,exchMassIo,8004h,6,0,2,
		( w(12) pbcb0 lfa p1 c(2,28) ),
		( noRouting ))

SysRequest(40,AllocExch,exchResex,0D00h,6,0,1,
		( p0 c(2,22) ),
		( noRouting ))

SysRequest(41,DeallocExch,exchResex,0D01h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(42,AllocMemorySL,exchMem,1,6,0,1,
		( w(12) p0 c(4,22) ),
		( noRouting ))

SysRequest(43,DeallocMemorySL,exchMem,2,6,0,0,
		( p(14) w(12) ),
		( noRouting ))

SysRequest(44,AllocMemoryLL,exchMem,3,6,0,1,
		( w(12) p0 c(4,22) ),
		( noRouting ))

SysRequest(45,DeallocMemoryLL,exchMem,4,6,0,0,
		( p(14) w(12) ),
		( noRouting ))

SysRequest(46,AllocAllMemorySL,exchMem,5,6,0,2,
		( p0 p1 c(2,22) c(4,28) ),
		( noRouting ))

SysRequest(47,ResetMemoryLL,exchMem,6,0,0,0,
		( none ),
		( noRouting ))

SysRequest(48,QueryMemAvail,exchMem,7,6,0,1,
		( p0 c(2,22) ),
		( noRouting ))

SysRequest(49,OpenRTClock,exchKbdRes,0300h,6,1,0,
		( p0 c(12,22) ),
		( noRouting ))

SysRequest(50,CloseRTClock,exchKbdRes,0400h,6,1,0,
		( p0 c(12,22) ),
		( noRouting ))

SysRequest(51,SetDateTime,exchFilSys3,0201h,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(52,Beep,exchKbdRes,0100h,0,0,0,
		( none ),
		( noRouting ))

SysRequest(53,ReadKbd,exchSysIn,0001h,6,0,1,
		( p0 c(2,22) ),
		( noRouting ))

SysRequest(54,ReadKbdDirect,exchKbd,0001h,6,0,1,
		( w(12) p0 c(1,22) ),
		( noRouting ))

SysRequest(55,QueryKbdLEDs,exchKbd,0003h,6,0,1,
		( p0 c(2,22) ),
		( noRouting ))

SysRequest(56,SetKbdLED,exchKbd,0004h,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(57,SetKbdUnencodedMode,exchSysIn,0005h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(58,QueryKbdState,exchSysIn,0006h,6,0,1,
		( p0 c(4,22) ),
		( noRouting ))

SysRequest(59,SetSysInMode,exchSysIn,0008h,4,0,0,
		( w(14) fh ),
		( noRouting ))

SysRequest(60,ReadActionCode,exchKbd,000Ah,6,0,1,
		( p0 c(2,22) ),
		( noRouting ))

SysRequest(61,QueryWSNum,exchFilSys4,0701h,6,0,1,
		( p0 c(2,22) ),
		( noRouting ))

SysRequest(62,CloseAllFilesLL,exchFilSys3,000Eh,0,0,0,
		( none ),
		( noRouting ))

SysRequest(63,KbdWakeUp,exchKbd,0002h,0,0,0,
		( none ),
		( noRouting )) 	; *2

SysRequest(64,BeeperOff,0,0200h,0,0,0,
		( none ),
		( noRouting )) 	; *2

SysRequest(65,SetKbdUnencodedModeReal,exchKbd,0005h,2,0,0,
		( w(12) ),
		( noRouting )) 	; *2

SysRequest(66,KbdResetSysIn,exchSysIn,000Ch,0,0,0,
		( none ),
		( noRouting )) 	; *2

SysRequest(67,DisableActionFinish,exchKbd,0007h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(68,CheckpointSysIn,exchSysIn,0009h,0,0,0,
		( none ),
		( noRouting ))

SysRequest(69,SetIntHandler,exchResex,0D0Bh,12,0,0,
		( w(12) p(14) w(18) w(20) w(22) ),
		( noRouting ))

SysRequest(70,ResetKbd,exchKbd,0000h,2,0,0,
		( w(12) ),
		( noRouting )) 	; *2

SysRequest(71,ResetSysIn,exchSysIn,0000h,2,0,0,
		( w(12) ),
		( noRouting )) 	; *2

SysRequest(72,ResetAgent,exchAgent,0000h,2,0,0,
		( w(12) ),
		( noRouting )) 	; *2

SysRequest(73,FileSystemTermination,exchFilSys3,000Dh,2,0,0,
		( none ),
		( noRouting ))

SysRequest(74,ResetVideo,exchVideo,0C00h,6,0,1,
		( b(12) b(13) b(14) b(15) p0 c(2,22) ),
		( noRouting ))

SysRequest(75,InitVidFrame,exchVideo,0C01h,10,0,0,
		( b(12) b(13) b(14) b(15) b(16) b(17)
		   b(18) b(19) b(20) b(21) ),
		( noRouting ))

SysRequest(76,InitCharMap,exchVideo,0C02h,6,0,1,
		( pbcb0 ),
		( noRouting ))

SysRequest(77,SetScreenVidAttr,exchVideo,0B01h,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(78,CloseISAM,exchISAM,8400h,2,0,1,
		( w(12) p(14) c(4,18) ),
		( rFh closeFh ))

SysRequest(79,CreateISAM,exchISAM,0001h,0,5,1,
		( p(12) w(16) p(18) w(22) p(24) w(28)
		   p(30) w(34) p(36) w(40) p(42) c(4,46) ),
		( FileSpec2 SpecPW ))

SysRequest(80,DeleteISAM,exchISAM,8002h,2,0,1,
		( w(12) p(14) c(4,18) ),
		( rFh closeFh ))

SysRequest(81,DeleteISAMRecord,exchISAM,0D803h,6,0,1,
		( w(12) p(14) p(18) c(4,22) ),
		( rFh ))

SysRequest(82,GetISAMRecords,exchISAM,0C004h,4,0,3,
		( w(12) b(14) p(16) w(20)
		   p(22) c(2,26) p(28) c(4,32) ),
		( rFh ))

SysRequest(83,LockISAM,exchISAM,0EFFFh,2,1,1,
		( w(12) p(14) w(18) p(20) c(4,24) ),
		( noRouting ))

SysRequest(84,ModifyISAMRecord,exchISAM,0D805h,6,1,1,
		( w(12) p(14) p(18) w(22) p(24) c(4,28) ),
		( rFh ))

SysRequest(85,OpenISAM,exchISAM,0006h,4,2,2,
		( p(28) c(2,32) p(16) w(20) p(22) w(26)
		   w(12) w(14) p(34) c(4,38) ),
		( FileSpec SpecPW openFh CloseAtTermination ))

SysRequest(86,ReadISAMRecordByUri,exchISAM,0C007h,6,0,2,
		( w(12) p(14) p(18) w(22) p(24) c(4,28) ),
		( rFh ))

SysRequest(87,ReadNextISAMRecord,exchISAM,0C008h,2,0,3,
		( w(12) p(14) w(18) p(20) c(4,24) p(26)
		   c(4,30) ),
		( rFh ))

SysRequest(88,ReadUniqueISAMRecord,exchISAM,0C009h,4,1,3,
		( w(12) w(14) p(16) w(20) p(22) w(26)
		   p(28) c(4,32) p(34) c(4,38) ),
		( rFh ))

SysRequest(89,RenameISAM,exchISAM,800Ah,2,4,1,
		( w(12) p(14) w(18) p(20) w(24)
		   p(26) w(30) p(32) w(36) p(38) c(4,42) ),
		( rFh FileSpec2 SpecPW ))

SysRequest(90,SetISAMProtection,exchISAM,800Bh,2,2,1,
		( w(12) p(14) w(18) p(20) w(24) p(26)
		   c(4,30) ),
		( rFh ))

SysRequest(91,SetupISAMIterationKey,exchISAM,0EFFFh,4,1,1,
		( w(12) w(14) p(16) w(20) p(22) c(4,26) ),
		( noRouting ))

SysRequest(92,SetupISAMIterationPrefix,exchISAM,800Ch,4,1,1,
		( w(12) w(14) p(16) w(20) p(22) c(4,26) ),
		( rFh ))

SysRequest(93,SetupISAMIterationRange,exchISAM,0EFFFh,6,2,1,
		( w(12) w(14) p(18) w(22) b(16) p(24)
		   w(28) b(17) p(30) c(4,34) ),
		( noRouting ))

SysRequest(94,StoreISAMRecord,exchISAM,0D80Dh,2,1,2,
		( w(12) p(14) w(18) p(20) c(4,24) p(26)
		c(4,30) ),
		( rFh ))

SysRequest(95,UnlockISAM,exchISAM,0EFFFh,0,0,1,
		( p(12) c(4,16) ),
		( noRouting ))

SysRequest(96,PurgeISAMUser,exchISAM,000Eh,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(97,OpenFileLL,exchFilSys1,0001h,6,2,1,
		( c(2,34) p2 pbcb0 pbcb1 w(14) ),
		( FileSpec SpecPW openFh ))

SysRequest(98,ConvertToSys,exchUser,21,0,0,0,
		( none),
		( none))

SysRequest(99,ServeRq,exchResex,0D0Dh,4,0,0,
		( w(12) w(14) ),
		( none))

SysRequest(100,GetClusterStatus,exchAgent,0000h,6,0,1,
		( w(12) pbcb0),
		( noRouting ))

SysRequest(101,SetCommISR,exchCommLine,0303h,22,0,0,
		( w(12) p(14) p(18) p(22) p(26) p(30)),
		( noRouting ))

SysRequest(102,ResetCommISR,exchCommLine,0305h,2,0,0,
		( w(12)),
		( noRouting ))

SysRequest(103,KbAttn3270,exch3270,0000h,6,2,0,
		( c(1,22) p(18) p(24) w(28)),
		( noRouting ))

SysRequest(104,ScreenRead3270,exch3270,0001h,6,2,0,
		( c(1,22) p(18) p(24) w(28)),
		( noRouting ))

SysRequest(105,StatusRead3270,exch3270,0002h,6,2,0,
		( c(1,22) p(18) p(24) w(28)),
		( noRouting ))

SysRequest(106,ReadyForCmd3270,exch3270,0003h,6,1,1,
		( c(1,22) p(18) p(24) w(28)),
		( noRouting ))

SysRequest(107,StartEm3270,exch3270,0004h,6,1,1,
		( c(1,22) p(18) p(24) w(28)),
		( noRouting ))

SysRequest(108,StopEm3270,exch3270,0005h,2,0,0,
		( w(12)),
		( noRouting ))

SysRequest(109,CancelRq3270,exch3270,0006h,6,1,0,
		( c(1,22) p(18)),
		( noRouting ))

SysRequest(110,ReportStatus3270,exch3270,0007h,6,1,1,
		( c(1,22) p(18) p(24) w(28)),
		( noRouting ))

SysRequest(111,SetVerifyCount,exchNotInstalled,0h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(112,FileSystemAbort,exchFilSys3,000Eh,2,0,0,
        ( none ),
		( noRouting ))

SysRequest(113,QuerySpooler,exchSplrOld,0000h,0,0,0,
		( none ),
		( noRouting ))

SysRequest(114,AddFileSpooler,exchSplrOld,0000h,4,4,0,
		( p(16) w(20) p(22) w(26) p(28) w(32) p(34) w(38) b(12) b(13) b(14) b(15) ),
		( noRouting ))

SysRequest(115,DelFileSpooler,exchSplrOld,0000h,0,2,0,
		( p(12) w(16) p(18) w(22) ),
		( noRouting ))

SysRequest(116,PausePrinter,exchSplrOld,0000h,0,1,0,
		( p(12) w(16) ),
		( noRouting ))

SysRequest(117,RestartPrinter,exchSplrOld,0000h,2,1,0,
		( p(14) w(18) w(12) ),
		( noRouting ))

SysRequest(118,CancelPrint,exchSplrOld,0000h,0,1,0,
		( p(12) w(16) ),
		( noRouting ))

SysRequest(119,GetSpoolerStatus,exchSplrOld,0004h,2,1,1,
		( p(14) w(18) w(12) p(20) w(24) ),
		( noRouting ))

SysRequest(120,GetNxtFilePrt,exchSplrOld,0000h,0,1,1,
		( p(12) w(16) p(18) w(22) ),
		( noRouting ))

SysRequest(121,SetLpISR,exchResex,0D10h,6,0,0,
		( p(14) w(12) ),
		( noRouting ))

SysRequest(122,DisableCluster,exchSrpAgent,0,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(123,GetRunFileHdr,exchResex,0E00h,6,0,1,
		( fh pbcb0 ),
		( rFh ))

SysRequest(124,QueryDcb,exchFilSys1,0805h,6,1,1,
		( pbcb0 pbcb1),
		( DevSpec ))

SysRequest(125,WriteLog,exchResex,0D12h,6,1,0,
		( pbcb0),
		( noRouting ))

SysRequest(126,SetCommISRRaw,exchCommLine,0304h,30,0,0,
		( w(12) p(14) p(18) p(22) p(26)
		p(30) w(34) w(36) w(38) w(40)),
		( noRouting ))

SysRequest(127,PurgeISAMTransaction,exchISAM,0EFFFh,0,0,1,
		( p(12) c(4,16) ),
		( noRouting ))

SysRequest(128,EndISAMTransaction,exchISAM,0EFFFh,0,0,1,
		( p(12) c(4,16) ),
		( noRouting ))

SysRequest(129,GetISAMRecordsHold,exchISAM,0F004h,4,0,3,
		( w(12) b(14) p(16) w(20)
		   p(22) c(2,26) p(28) c(4,32) ),
		( rFh ))

SysRequest(130,HoldISAMRecord,exchISAM,0D00Fh,6,0,1,
		( w(12) p(14) p(18) c(4,22) ),
		( rFh ))

SysRequest(131,ReadISAMRecordByUriHold,exchISAM,0F007h,6,0,2,
		( w(12) p(14) p(18) w(22) p(24) c(4,28) ),
		( rFh ))

SysRequest(132,ReadNextISAMRecordHold,exchISAM,0F008h,2,0,3,
		( w(12) p(14) w(18) p(20) c(4,24) p(26)
		   c(4,30) ),
		( rFh ))

SysRequest(133,ReadUniqueISAMRecordHold,exchISAM,0F009h,4,1,3,
		( w(12) w(14) p(16) w(20) p(22) w(26)
		   p(28) c(4,32) p(34) c(4,38) ),
		( rFh ))

SysRequest(134,ReleaseISAMRecord,exchISAM,0D410h,6,0,1,
		( w(12) p(14) p(18) c(4,22) ),
		( rFh ))

SysRequest(135,SetupISAMIteration,exchISAM,0EFFFh,4,1,1,
		( w(12) w(14) p(16) w(20) p(22) c(4,26) ),
		( noRouting ))

SysRequest(136,StartISAMTransaction,exchISAM,0EFFFh,4,1,1,
		( b(12) w(14) p(16) w(20) p(22) c(4,26) ),
		( noRouting ))

SysRequest(137,AddQueueEntry,exchQueMgr,0000h,6,3,0,
        ( p(18) w(22) b(12) b(13)   w(14)
        p(24) w(28) p(30) c(4,34) w(16) ),
		( DevSpec ))

SysRequest(138,RemoveKeyedQueueEntry,exchQueMgr,0001h,4,3,0,
        ( p(16) w(20) p(22) w(26) w(12) p(28) w(32) w(14) ),
		( DevSpec ))

SysRequest(139,ReadNextQueueEntry,exchQueMgr,0002h,4,1,2,
        ( p(16) w(20) p(12) p(22) w(26) p(28) w(32) ),
		( DevSpec ))

SysRequest(140,ReadKeyedQueueEntry,exchQueMgr,0003h,4,3,2,
        ( p(16) w(20) p(22) w(26) w(12)
        p(28) w(32) w(14) p(34) w(38) p(40) w(44) ),
		( DevSpec ))

SysRequest(141,MarkNextQueueEntry,exchQueMgr,0004h,2,1,2,
        ( p(14) w(18) b(12) p(20) w(24) p(26) w(30) ),
		( DevSpec ))

SysRequest(142,MarkKeyedQueueEntry,exchQueMgr,0005h,4,3,2,
        ( p(16) w(20) p(22) w(26) w(12) p(28)
        w(32) w(14) p(34) w(38) p(40) w(44) ),
		( DevSpec ))

SysRequest(143,RemoveMarkedQueueEntry,exchQueMgr,0006h,4,1,0,
        ( p(16) w(20) p(12) ),
		( DevSpec ))

SysRequest(144,UnMarkQueueEntry,exchQueMgr,0007h,4,1,0,
        ( p(16) w(20) p(12) ),
		( DevSpec ))

SysRequest(145,ReWriteMarkedQueueEntry,exchQueMgr,0008h,4,2,0,
        ( p(16) w(20) p(12) p(22) w(26) ),
		( DevSpec ))

SysRequest(146,EstablishQueueServer,exchQueMgr,0009h,4,1,0,
        ( p(16) w(20) w(12) b(14) ),
		( DevSpec ))

SysRequest(147,TerminateQueueServer,exchQueMgr,000Ah,0,1,0,
        ( p(12) w(16) ),
		( noRouting ))

SysRequest(148,PurgeQueueServer,exchQueMgr,000Bh,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(149,SignoffRJE,exchRJE,0000h,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(150,SignonRJE,exchRJE,0000h,0,2,0,
        ( p(12) w(16) p(18) w(22) ),
		( noRouting ))

SysRequest(151,StatusRJE,exchRJE,0000h,0,0,2,
        ( p(12) c(2,16) p(18) w(22) ),
		( noRouting ))

SysRequest(152,AcceptCommCall,exchCommSer,0000h,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(153,CloseAllCommLines,exchCommSer,0001h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(154,CloseCommLine,exchCommSer,0002h,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(155,DialComm,exchCommSer,0003h,2,1,0,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(156,DisconnectComm,exchCommSer,0004h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(157,FlushCommBuffer,exchCommSer,0005h,4,0,0,
		( w(12) b(14) ),
		( noRouting ))

SysRequest(158,GetCommParameters,exchCommSer,0006h,2,0,1,
		( w(12) p(14) c(20,18) ),
		( noRouting ))

SysRequest(159,OpenCommLine,exchCommSer,0007h,4,2,1,
		( b(12) p(16) w(20) p(22) w(26) w(14) p(28) c(2,32) ),
		( noRouting ))

SysRequest(160,ReadComm,exchCommSer,0008h,4,0,2,
		( w(12) w(14) p(16) w(20) p(22) c(2,26) ),
		( noRouting ))

SysRequest(161,SetCommParameters,exchCommSer,0009h,2,1,0,
		( w(12) p(14) c(20,18) ),
		( noRouting ))

SysRequest(162,WriteComm,exchCommSer,000Ah,4,1,1,
		( w(12) w(14) p(16) w(20) p(22) c(2,26) ),
		( noRouting ))

SysRequest(163,BreakComm,exchCommSer,000Bh,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(164,ResetQueMgr,exchQueMgr,0000h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(165,NotifyNextIncomingCall,exchX25,0,8,1,3,
        ( w(12) p(38) c(2,42) p(26) w(30) p(32) c(2,36)
        p(20) w(24) w(14) w(16) w(18) ),
		( noRouting ))

SysRequest(166,AcceptX25Call,exchX25,0,6,2,0,
        ( w(12) p(18) w(22) p(24) w(28) w(16) ),
		( noRouting ))

SysRequest(167,InitiateX25Call,exchX25,0,6,3,3,
        ( w(12) p(36) c(2,40) p(42) w(46) p(48) c(2,52)
		p(30) w(34) p(18) w(22) p(24) w(28) w(14) ),
		( noRouting ))

SysRequest(168,ClearX25Call,exchX25,0,6,1,0,
		( w(12) w(14) p(18) w(22) ),
		( noRouting ))

SysRequest(169,PurgeX25User,exchX25,0,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(170,ReadX25Packet,exchX25,0,6,0,3,
		( w(12) p(18) w(22) p(24) c(2,28)
		p(30) c(1,34) w(14) ),
		( noRouting ))

SysRequest(171,WriteX25Packet,exchX25,0,6,1,0,
		( w(12) w(14) p(18) w(22) ),
		( noRouting ))

SysRequest(172,WriteX25Interrupt,exchX25,0,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(173,ResetX25Call,exchX25,0,2,0,0,
		( w(12) w(14) ),
		( noRouting ))

SysRequest(174,QueryX25Status,exchX25,0,8,0,2,
		( w(12) p(20) w(24) b(14) b(15)
		w(16) w(18) p(26) c(1,30) ),
		( noRouting ))

SysRequest(175,ConnectX25Permanent,exchX25,0,2,0,1,
		( w(12) p(14) c(2,18) ),
		( noRouting ))

SysRequest(176,DeletePartition,exchUser,23,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(177,GetPartitionHandle,exchTask,0F02h,0,1,1,
        ( p(12) w(16) p(18) c(2,22) ),
		( noRouting ))

SysRequest(178,LoadPrimaryTask,exchTerm,0100h,6,2,0,
        ( w(12) p(18) w(22) p(24) w(28) w(14) ),
		( noRouting ))

SysRequest(179,TerminatePartition,exchTask,0F03h,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(180,VacatePartition,exchTerm,0002h,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(181,CreatePartition,exchUser,22,6,1,1,
        ( p(18) w(22) w(12) b(14) p(24) c(2,28) ),
		( noRouting ))

SysRequest(182,SetPartitionLock,exchTask,0F04h,2,0,0,
        ( b(12) ),
		( noRouting ))

SysRequest(183,SetPartitionExch,exchTask,0F05h,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(184,GetPartitionExch,exchTask,0F06h,2,0,1,
        ( w(12) p(14) c(2,18) ),
		( noRouting ))

SysRequest(185,GetPartitionStatus,exchTask,0F07h,4,0,1,
        ( w(12) w(14) p(16) w(20) ),
		( noRouting ))

SysRequest(186,SetExitRunFile,exchTask,0D09h,6,2,0,
        ( p(18) w(22) p(24) w(28) w(12) ),
		( noRouting ))

SysRequest(187,QueryExitRunFile,exchTask,0D0Ah,6,0,3,
        ( p(18) w(22) p(24) w(28) p(30) c(2,34) ),
		( noRouting ))

SysRequest(188,ConfigureSpooler, exchSplr,0000h,6,3,0,
		( b(12) pbcb0 pbcb1 pbcb2 b(13) b(14) ),
		( FileSpecP2S2 ))

SysRequest(189,SpoolerPassword,exchSplr,0001h,6,2,0,
		( pbcb0 pbcb1 ),
		( noRouting ))

SysRequest(190,OpenTape,exchTape,0,6,1,1,
		( pbcb0 b(12) b(13) b(14) w(16) p1 c(2,28) ),
		( DevSpec openFh CloseAtTermination ))

SysRequest(191,ReadTapeRecords,exchTape,1,6,0,3,
		( fh w(14) pbcb0 p1 c(2,28) p2 c(2,34) ),
		( rFh ))

SysRequest(192,WriteTapeRecords,exchTape,2,6,1,2,
		( fh w(14) pbcb0 p1 c(2,28) p2 c(2,34) ),
		( rFh ))

SysRequest(193,TapeOperation,exchTape,3,6,0,0,
		( fh b(14) b(15) w(16) ),
		( rFh ))

SysRequest(194,CloseTape,exchTape,4,2,0,0,
		( fh ),
		( rFh CloseFh ))

SysRequest(195,PurgeTapeUser,exchTape,5,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(196,TapeStatus,exchTape,6,6,0,1,
		( fh p0 c(2,22) ),
		( rFh ))

SysRequest(197,ResetSplr,exchSplr,0000h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(198,ModifyISAMRecordByKey,exchISAM,0F811h,4,1,2,
		( w(12) w(14) p(16) w(20) p(22) c(4,26) p(28) c(4,32) ),
		( rFh ))

SysRequest(199,DeleteISAMRecordByKey,exchISAM,0F812h,4,1,2,
		( w(12) w(14) p(16) w(20) p(22) c(4,26) p(28) c(4,32) ),
		( rFh ))

SysRequest(200,LogRemote,exchLog,0D11h,6,2,0,
		( pbcb0 pbcb1 ),
		( noRouting ))

SysRequest(201,VacateParCleanup,exchMaster,0000h,0,0,0,
		( none),
		( noRouting ))

SysRequest(202,GetWsUserName,exchFilSys4,0702h,6,0,1,
		( w(12) pbcb0 ),
		( noRouting ))

SysRequest(203,SetWsUserName,exchFilSys4,0703h,6,1,0,
		( pbcb0 ),
		( noRouting ))

SysRequest(204,FinishISAMCommit,exchISAM,0013h,0,1,1,
		( p(12) w(16) p(18) c(4,22) ),
		( DevSpec ))

SysRequest(205,HoldISAMDataSet,exchISAM,0D014h,4,0,1,
		( w(12) b(14) p(16) c(4,20) ),
		( rFh ))

SysRequest(206,ReleaseISAMDataSet,exchISAM,0D415h,2,0,1,
		( w(12) p(14) c(4,18) ),
		( rFh ))

SysRequest(207,RollbackISAMTransaction,exchISAM,0016h,0,1,1,
		( p(12) w(16) p(18) c(4,22) ),
		( DevSpec ))

SysRequest(208,SetISAMTransactionParams,exchISAM,0017h,0,2,1,
		( p(12) w(16) p(18) w(22)
		   p(24) c(4,28)),
		( DevSpec ))

SysRequest(209,StartISAMCommit,exchISAM,0018h,0,2,1,
		( p(12) w(16) p(18) w(22)
		   p(24) c(4,28) ),
		( DevSpec ))

SysRequest(210,SetupISAMIterationLimits,exchISAM,8019h,6,2,1,
		( w(12) w(14) b(16) p(18) w(22)
           p(24) w(28) p(30) c(4,34) ),
		( rFh ))

SysRequest(211,BeginISAMTransaction,exchISAM,001Ah,0,1,2,
		( p(12) w(16) p(18) c(7,22)
		p(24) c(4,28) ),
		( DevSpec ))

SysRequest(212,DbResourceRequest,exchDBMS,0FFFFh,10,3,3,
		( ),
		( DevSpec openFh CloseAtTermination ))

SysRequest(213,DbCloseRequest,exchDBMS,0FFFFh,10,3,3,
		( ),
		( rFh closeFh ))

SysRequest(214,DbHandleRequest,exchDBMS,0FFFFh,10,3,3,
		( ),
		( rFh ))

SysRequest(215,ChangeOpenMode,exchMassIo,0006h,6,1,0,
		( fh pbcb0 w(14) ),
		( rFh SpecPW ))

SysRequest(216,GetDirStatus,exchFilSys1,0007h,6,2,1,
		( pbcb0 pbcb1 w(12) pbcb2 ),
		( DirSpec SpecPW ))

SysRequest(217,SetDirStatus,exchFilSys1,0008h,6,3,0,
		( pbcb0 pbcb1 w(12) pbcb2 ),
		( DirSpec SpecPW ))

SysRequest(218,ChangeUserNumQmg,exchQueMgr,0000h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(219,ChangeUserNumFs,exchChgUsrN,0013h,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(220,ReadSNAPIU,exchSNA,0,6,0,4,
        ( w(12) w(14) w(16) p(18) w(22) p(24) w(28)
        p(30) w(34) p(36) w(40) ),
		( rFh ))

SysRequest(221,WriteSNAPIU,exchSNA,0,2,1,0,
        ( w(12) p(14) w(18) ),
		( rFh ))

SysRequest(222,XWriteSNAPIU,exchSNA,0,2,1,0,
        ( w(12) p(14) w(18) ),
		( rFh ))

SysRequest(223,AttachLu,exchSNA,0,4,0,1,
        ( w(12) p(16) c(2,20) b(14)  ),
		( noRouting ))

SysRequest(224,InitiateSNASession,exchSNA,0,2,5,0,
		( w(12) p(14) w(18) p(20) w(24) p(26)
		   w(30) p(32) w(36) p(38) w(42) ),
		( rFh ))

SysRequest(225,NotifyNextIncomingBind,exchSNA,0,4,0,2,
        ( w(12) w(14) p(16) w(20) p(22) w(26) ),
		( rFh ))

SysRequest(226,TerminateSNASession,exchSNA,0,2,0,0,
        ( w(12) ),
		( rFh ))

SysRequest(227,AcceptSNASession,exchSNA,0,2,1,0,
        ( w(12) p(14) w(18) ),
		( rFh ))

SysRequest(228,RejectSNASession,exchSNA,0,2,1,0,
        ( w(12) p(14) w(18) ),
		( rFh ))

SysRequest(229,PurgeSNAUser,exchSNA,0,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(230,CloseSNASession,exchSNA,0,2,1,0,
        ( w(12) p(14) w(18) ),
		( rFh ))

SysRequest(231,DetachLu,exchSNA,0,2,0,0,
        ( w(12) ),
		( rFh CloseFh))

SysRequest(232,QuerySNAStatus,exchSNA,0,8,0,2,
        ( b(14) w(16) p(20) w(24) p(26) c(1,30) ),
		( noRouting ))

SysRequest(233,TerminateSNAUser,exchSNA,0,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(234,AcknowledgeMailReceipt,exchMailSer,0,6,1,0,
		( w(12) p(18) c(12,22) w(14) w(16) ),
		( rFh ))

SysRequest(235,CheckForMail,exchMailSer,1,4,1,2,
		( p(12) p(16) w(20) p(22) c(2,26) p(28) c(2,32) ),
		( DevSpec ))

SysRequest(236,ConfigureMail,exchMailSer,2,4,2,0,
		( w(12) w(14) p(16) w(20) p(22) w(26) ),
		( rFh ))

SysRequest(237,ConnectNextMailCenter,exchMailSer,3,2,0,2,
		( w(12) p(14) c(2,18) p(20) w(24) ),
		( rFh OpenFh CloseAtTermination))

SysRequest(238,EstablishMailConnection,exchMailSer,4,0,2,2,
		( p(12) w(16) p(18) w(22) p(24) c(2,28) p(30) w(34) ),
		( DevSpec OpenFh CloseAtTermination))

SysRequest(239,PurgeMailUser,exchMailSer,5,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(240,QueryMailConfiguration,exchMailSer,6,4,2,2,
		( w(12) w(14) p(16) w(20) p(22) w(26)
		p(28) w(32) p(34) c(2,38) ),
		( rFh ))

SysRequest(241,QueryMailStatus,exchMailSer,7,6,0,2,
		( w(12) w(14) w(16) p(18) w(22) p(24) c(2,28) ),
		( rFh ))

SysRequest(242,QueryMailUniqueId,exchMailSer,8,2,0,1,
		( w(12) p(14) c(4,18) ),
		( rFh ))

SysRequest(243,QueryServerForUser,exchMailSer,9,0,2,1,
		( p(12) w(16) p(18) w(22) p(24) c(2,28) ),
		( DevSpec ))

SysRequest(244,ReceiveMail,exchMailSer,10,2,0,3,
		( w(12) p(14) w(18) p(20) c(2,24) p(26) c(12,30) ),
		( rFh ))

SysRequest(245,ResetMailServer,exchMailSer,11,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(246,SendMail,exchMailSer,12,4,2,1,
		( w(12) p(16) w(20) p(22) w(26) p(28) c(12,32) w(14) ),
		( rFh ))

SysRequest(247,SignoffMailUser,exchMailSer,13,4,1,0,
		( p(16) w(20) p(12) ),
		( DevSpec ))

SysRequest(248,TerminateMailConnection,exchMailSer,14,2,0,0,
	 	( w(12) ),
		( rFh closeFh ))

SysRequest(249,ValidateMail,exchMailSer,15,2,2,2,
		( w(12) p(14) w(18) p(20) w(24)
        p(26) c(1,30) p(32) c(2,36) ),
		( rFh ))

SysRequest(250,SetMailAgentStatus,exchMailSer,16,2,1,0,
		( w(12) p(14) w(18) ),
		( rFh ))

SysRequest(251,PurgeMailUniqueId,exchMailSer,17,2,0,0,
		( none),
		( noRouting ))

SysRequest(252,SetNode,exchResex,0D16h,6,1,0,
		( pbcb0 ),
		( noRouting ))

SysRequest(253,ExpandSpec,exchFilSys1,0806h,6,2,1,
		( pbcb0 pbcb1 pbcb2 fh ),
		( NoRouting ))

SysRequest(254,QueryExchange,exchResex,0D18h,6,0,1,
		( fh p0 c(2,22) ),
		( NoRouting ))

SysRequest(255,SetVideoTimeout,exchKbd,000Bh,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(256,ReadActionKbd,exchKbd,000Ch,6,0,1,
		( b(12) p0 c(1,22) ),
		( NoRouting ))

SysRequest(257,ReadKbdStatus,exchKbd,000Dh,6,0,2,
		( w(12) p0 c(2,22) p1 c(1,28) ),
		( NoRouting ))

SysRequest(258,NotifyCM,exchNotPresent,0,6,1,0,
		( w(12) pbcb0 ),
		( NoRouting ))

SysRequest(259,ChangeUserNumMail,exchMailSer,18,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(260,QuietMailUser,exchMailSer,19,2,0,0,
		( w(12) ),
		( noRouting ))

SysRequest(261,OSVersion,exchKbdRes,0500h,0,0,1,
		( p(12) c(2,16) ),
		( NoRouting ))

SysRequest(262,LoadInterActiveTask,exchTerm,0100h,6,2,0,
        ( w(12) p(18) w(22) p(24) w(28) w(14) w(16)),
		( noRouting ))

SysRequest(263,TerminateISAMServer,exchISAM,001Bh,0,0,2,
        ( p(12) c(2,16) p(18) c(4,22)),
		( noRouting ))

SysRequest(264,MapXBusWindow,exchResex,0D1Ah,6,0,2,
        ( b(12) b(13) p(18) c(4,22) w(14) p(24)
            c(2,28) w(16)),
		( noRouting ))

SysRequest(265,QuietKbdForSwap,exchKbd,0000h,2,0,0,
		( w(12) ),
		( noRouting ))	; *2

SysRequest(266,Purge3270Em,exchNotPresent,0000h,2,0,0,
		(  ),
		( noRouting ))

SysRequest(267,PurgeX25,exchNotPresent,0000h,2,0,0,
		(  ),
		( noRouting ))	;*2

SysRequest(268,SetTrapHandler,exchResex,0D0Bh,12,0,0,
		( w(12) p(14)  c(0FFh, 22) ),
		( noRouting ))

SysRequest(269,QueryNodeForMailUser,exchMailSer,20,0,2,2,
	 	( p(12) w(16) p(18) w(22) p(24) w(28) p(30) c(2,34) ),
		( DevSpec ))

SysRequest(270,(CtNetTermination),exchNotInstalled,0000h,2,0,0,
		( none ),
		( noRouting ))

SysRequest(271,QueryRequestInfo,exchResex,0D18h,6,0,1,
		( fh pbcb0 ),
		( NoRouting ))

SysRequest(272,GetUserStatus,exchResex,0700h,6,0,1,
		( fh pbcb0 ),
		( noRouting )) 

SysRequest(273,CMTermination,exchNotPresent,0000h,2,0,0,
		( none ),
		( noRouting ))

SysRequest(274,FilterProsTermination,exchFilterPros,0000h,2,0,0,
		( none ),
		( noRouting ))

SysRequest(275,VacatePartitionA,exchTask,0E01h,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(276,VacatePartitionB,exchTask,0E02h,2,0,0,
        ( w(12) ),
		( noRouting ))

SysRequest(277,SetVectorArea,exchResex,0D1Bh,6,0,1,
		( fh w(14) p0 c(1,22) ),
		( noRouting ))

SysRequest(278,AllocAreaSL,exchMem,8,6,0,1,
		( w(12) p0 c(4,22) ),
		( noRouting ))

SysRequest(279,ExpandAreaSL,exchMem,9,6,0,1,
		( w(12) w(14) p0 c(2,22) ),
		( noRouting ))

SysRequest(280,ExpandAreaLL,exchMem,10,6,0,1,
		( w(12) w(14) p0 c(2,22) ),
		( noRouting ))

SysRequest(281,ShrinkAreaSL,exchMem,11,6,0,0,
		( p(14) w(12) ),
		( noRouting ))

SysRequest(282,ShrinkAreaLL,exchMem,12,6,0,0,
		( p(14) w(12) ),
		( noRouting ))

SysRequest(283,QueryBigMemAvail,exchMem,13,6,0,1,
		( p0 c(4,22) ),
		( noRouting ))

SysRequest(284,CreateAlias,exchSched,14,6,0,1,
		( p(14) p0 c(2,22) ),
		( noRouting ))

SysRequest(285,SetSegmentAccess,exchSched,0,6,0,0,
		( w(12) b(14) ),
		( noRouting ))

SysRequest(286,SetColorData,exchVideo,0C04h,0,2,2,
		( p(12) w(16) pbcb0 pbcb1 pbcb2  ),
		( noRouting ))

SysRequest(287,ProgramColorMapper,exchNotPresent,0,0,2,2,
		( p(12) w(16) pbcb0 pbcb1 pbcb2  ),
		( noRouting ))

SysRequest(288,SetCommISRRawSFN,exchCommLine,0304h,30,0,0,
		( w(12) p(14) p(18) p(22) p(26)
		p(30) w(34) w(36) w(38) w(40)),
		( noRouting ))

SysRequest(289,OpenQueue,exchQueMgr,0000h,4,2,0,
		( p(16) w(20) p(22) w(26) w(12) w(14)),
		( noRouting ))

SysRequest(290,ResetMemorySL,exchSched,15,0,0,0,
		( none ),
		( noRouting ))

SysRequest(291,ResetAllSegs,exchSched,16,0,0,0,
		( none ),
		( noRouting ))

SysRequest(292,FreeLargeLL,exchSched,17,0,0,0,
		( none ),
		( noRouting ))

SysRequest(293,LoadFile,exchMem,22,10,0,3,
		( fh w(14) w(16) w(18) c(0,20) p(22) w(26) p(28) w(32) p(34) w(38) ),
		( noRouting ))

SysRequest(294,ReOpenFile,exchFilSys1,0001h,6,2,1,
		( c(2,34) p2 pbcb0 pbcb1 w(14) ),
		( FileSpec SpecPW openFh CloseAtTermination))

SysRequest(295,SwapInContext,exchSched,22,2,0,0,
		( fh ),
		( noRouting ))

SysRequest(296,CreateUser,exchSched,22,6,1,1,
        ( p(18) w(22) w(12) c(4,14) p(24) c(2,28) w(16) ),
		( noRouting ))

SysRequest(297,GetHandleStatus,exchFilSys1,0702h,6,1,1,
		( pbcb0 fh pbcb1 ),
		( DevSpec ))

SysRequest(298,unused,0,0h,0,0,0,
		(  ),
		( noRouting ))

SysRequest(299,AllocMemoryReal,exchMem,18,6,0,1,
		( w(12) p0 c(4,22) ),
		( noRouting ))

SysRequest(300,DeallocMemoryReal,exchMem,18,6,0,0,
		( p(14) w(12) ),
		( noRouting ))

SysRequest(301,CallSourceDbgNub,exchKbd,0600h,6,1,1,
        ( fh p0 c(2,22) p1 c(4,28) ),
        ( noRouting ))

SysRequest(302,QueryNodeName,exchNotInstalled,0,0,0,2,
        ( p(12) w(16) p(18) c(2,22) ),
		( noRouting ))

SysRequest(303,ReadSwap,exchSched,22,6,0,3,
        ( fh w(16) w(14) pbcb0 p1 c(2,28) p2 c(2,34) ),
		( noRouting ))

SysRequest(304,WriteSwap,exchSched,22,6,1,0,
        ( fh w(16) w(14)  pbcb0 ),
		( noRouting ))

SysRequest(305,DeactivateRunFile,exchSched,22,2,0,0,
        ( fh ),
		( noRouting ))

SysRequest(306,GetMemoryInfo,exchMem,24,6,0,2,
		( pbcb0 p1 c(2,28) ),
		( noRouting ))

SysRequest(307,ReservedForOem,0,0,0,0,0,
		( none ),
		( noRouting ))

SysRequest(308,AllocUserNumbers,exchResex,0D80h,6,0,1,
		( fh p0 c(6,22) c(0,23) ),
		( noRouting ))

SysRequest(309,DeallocUserNumbers,exchResex,0D81h,6,0,0,
		( fh ),
		( noRouting ))

SysRequest(310,Sync1,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(311,Sync2,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(312,Sync3,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(313,Sync4,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(314,Sync5,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(315,Sync6,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(316,Sync7,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(317,Sync8,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

SysRequest(318,DoDirectRead,exchFilSys2,0100h,6,1,2,
		( fh pbcb0 pbcb1 pbcb2 w(14) w(16) ),
		( rFh RW ))

SysRequest(319,DoDirectWrite,exchFilSys2,0101h,6,2,1,
		( fh pbcb0 pbcb1 pbcb2 w(14) w(16) ),
		( rFh RW ))

SysRequest(320,DefineLocalPageMap,exchMem,27,8,0,0,
		( p(12) w(16) w(18) ),
		( noRouting ))

SysRequest(321,MapXBusWindowLarge,exchResex,0D25h,6,0,3,
        ( b(12) b(13) p(18) w(22) p(30) c(2,34) w(14)
            p(24) c(2,28) w(16)),
		( noRouting ))

SysRequest(322,Set386TrapHandler,exchResex,0D0Bh,12,0,0,
		( w(12) p(14)  c(255, 22) c(255, 23) ),
		( noRouting ))

SysRequest(323,ServiceOverlayA,exchSched,28,2,1,0,
        ( p(14) c(2, 18) c(0, 19) w(12) ),
		( noRouting ))

SysRequest(324,ServiceOverlayB,exchSched,29,4,0,0,
        ( w(14) w(12) ),
		( noRouting ))

SysRequest(325,AllocMemoryFrameSL,exchMem,25,6,0,1,
		( w(12) p0 c(4,22) ),
		( noRouting ))

SysRequest(326,InitLocalPageMap,exchMem,26,4,0,0,
		( p(12) ),
		( noRouting ))

SysRequest(327,LinkFile,exchFilSys1,0014h,6,2,0,
		( fh pbcb0 pbcb1 ),
		( rFh FileSpec SpecPw ))

SysRequest(328,MakeDirectory,exchFilSys1,0003h,6,3,0,
		( pbcb0 pbcb1 pbcb2 w(14) w(16) ),
		( FileSpec SpecPW ))

SysRequest(329,RemoveDirectory,exchFilSys1,0004h,2,0,0,
		( fh ),
		( rFh closeFh ))

SysRequest(330,ReservedForOEM,0,0h,0,0,0,
		(  ),
		(  ))

SysRequest(331,CreateBigPartition,exchUser,22,6,1,1,
        ( p(18) w(22) w(16) w(12) b(14) p(24) c(2,28) ),
		( noRouting ))

SysRequest(332,SgFromSn,exchSched,30,6,0,1,
		( w(16) w(14) p0 c(2,22) ),
		( noRouting ))

SysRequest(333,AllocLdtSlot,exchSched,31,6,0,1,
		( p0 c(2,22) ),
		( noRouting ))

SysRequest(334,FSCableDrop,exchFilSys1,0808h,6,0,0,
		( ),
		( noRouting ))

SysRequest(335,FilterDebugInterrupts,exchResex,0D26h,6,0,0,
		( w(12) w(14) b(16) ),
		( noRouting ))

SysRequest(336,RemakeAliasForServer,exchSched,32,6,0,1,
		( w(16) w(14) p0 c(2,22) ),
		( noRouting ))

SysRequest(337,DeallocAliasForServer,exchSched,33,6,0,0,
		( w(16) w(14) ),
		( noRouting ))

SysRequest(338,AllocMemoryPermanent,exchMem,34,6,0,1,
		( w(12) p0 c(4,22) ),
		( noRouting ))

SysRequest(339,SetDefaultTrapHandler,exchResex,0D0Bh,12,0,1,
		( w(12) p(14)  p1 c(0FFh, 22) c(4,28) ),
		( noRouting ))

SysRequest(340,QueryDeviceNames,exchFilSys1,0809h,6,1,2,
		( pbcb0 pbcb1 p2 c(2,34) ),
		( DevSpec ))

SysRequest(341,ShrinkPartition,exchUser,35,0,0,0,
		( none),
		( none))

SysRequest(342,CreateExpandDownAlias,exchSched,36,6,0,1,
		( p(14) w(12) p0 c(2,22) ),
		( noRouting ))

SysRequest(343,AccessSystemCall,exchMem,37,4,0,1,
		( w(12) w(14) p(16) c(4,20) ),
		( noRouting ))

SysRequest(344,InstallNet,exchKbd,0700h,6,1,0,
		( fh pbCb0 ),
		(noRouting))

SysRequest(345,DeallocSg,exchMem,38,6,0,0,
		( w(12) w(14)),
		( noRouting ))

SysRequest(346,QueryDeviceName,exchFilSys1,0809h,6,1,2,
		( pbcb0 fh pbcb1 p2 c(2,34) ),
		( DevSpec ))

SysRequest(347,ReadKbdDataDirect,exchKbd,0001h,6,0,1,
		( w(12) pbcb0 ),
		( NoRouting ))

SysRequest(348,SetIBusHandler,exchKbd,0600h,6,0,0,
		( w(12) p(14)),
		( noRouting ))

SysRequest(349,ResetIBusHandler,exchKbd,0600h,6,0,0,
		( w(12) p(14)),
		( noRouting ))

SysRequest(350,LoadRunFile,exchTerm,0004h,6,0,2,
		( fh w(14) w(16) p0 c(4,22) pbcb1 ),
		( noRouting ))

SysRequest(351,DeallocRunFile,exchMem,39,6,0,0,
		( w(14) w(12)),
		( noRouting ))

SysRequest(352,SetFSConfigParams,exchFilSys1,080Ah,6,1,0,
		( pbcb0 ),
		( noRouting ))

SysRequest(353,GetSCSIInfo,exchFilSys1,080Bh,6,0,2,
		( w(12) w(14) w(16) pbcb0 p1 c(2,28)),
		( noRouting ))

SysRequest(354,ReservePartitionMemory,exchMem,40,6,0,1,
		( w(12) w(14) p0 c(2,22) ),
		( noRouting ))

; requests 355 to 363 are reserved for SCSI requests

SysRequest(355,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(356,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(357,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(358,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(359,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(360,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(361,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(362,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(363,rsvdSCSI,0,0000h,0,0,0,
		( illegal ),
		( noRouting ))

SysRequest(364,GetPartitionSwapMode,exchTask,0F08h,2,0,1,
        ( w(12) p(14) c(2,18) ),
		( noRouting ))

SysRequest(365,SetPartitionSwapMode,exchTask,0F09h,4,0,0,
        ( w(12) w(14) ),
		( noRouting ))

; Requests 366 to 390, and 392 to 393 are reserved for 3.0 requests


SysRequest(366,QueryDiskGeometry,exchNotPresent,80Ch,6,2,1,
		( illegal ),
		( noRouting ))

SysRequest(367,SetDiskGeometry,exchNotPresent,80Dh,6,3,0,
		( illegal ),
		( noRouting ))

SysRequest(368,GetRemoteStructure,exchNotPresent,0705h,6,1,2,
		( illegal ),
		( noRouting ))

SysRequest(369,GetRemotepStructure,exchNotPresent,0706h,6,1,1,
		( illegal ),
		( noRouting ))

SysRequest(370,TerminateScsiUser,exchNotPresent,0700h,2,0,0,
		( illegal ),
		( noRouting ))

SysRequest(371,QuietScsiUserForSwap,exchNotPresent,0700h,2,0,0,
		( illegal ),
		( noRouting ))

SysRequest(372,AllocateDiskPages,exchNotPresent,0703h,6,1,1,
		( illegal ),
		( noRouting ))

SysRequest(373,LockInCache,exchNotPresent,0400h,12,0,1,
		( illegal ),
		( noRouting ))

SysRequest(374,UnLockInCache,exchNotPresent,0400h,12,0,1,
		( illegal ),
		( noRouting ))

SysRequest(375,RemoteCacheUp,exchNotPresent,080Eh,0,3,0,
		( illegal ),
		( noRouting ))

SysRequest(376,RemoteCacheOpen,exchNotPresent,0,2,4,1,
		( illegal ),
		( noRouting ))

SysRequest(377,RemoteCacheClose,exchNotPresent,8001h,4,0,0,
		( illegal ),
		( noRouting ))

SysRequest(378,RemoteCacheGetStatistics,exchNotPresent,8002h,4,0,2,
		( illegal ),
		( noRouting ))

SysRequest(379,RemoteCacheGetEntry,exchNotPresent,0C003h,8,2,1,
		( illegal ),
		( noRouting ))

SysRequest(380,RemoteCacheReleaseEntry,exchNotPresent,0C004h,14,1,0,
		( illegal ),
		( noRouting ))

SysRequest(381,RemoteCacheFlush,exchNotPresent,8005h,8,2,1,
		( illegal ),
		( noRouting ))

SysRequest(382,RemoteCacheProbe,exchNotPresent,0E006h,10,1,0,
		( illegal ),
		( noRouting ))

SysRequest(383,RemoteCacheRelease,exchNotPresent,0E007h,10,1,0,
		( illegal ),
		( noRouting ))

SysRequest(384,ResetRemoteCache,exchNotPresent,8,2,0,0,
		( illegal ),
		( noRouting ))

SysRequest(385,QuietRemoteCache,exchNotPresent,8,2,0,0,
		( illegal ),
		( noRouting ))

SysRequest(386,RemoteCacheControl,exchNotPresent,9,2,1,1,
		( illegal ),
		( noRouting ))

SysRequest(387,ScsiTargetDataReceive,exchNotPresent,0406h,6,0,5,
		( illegal ),
		( noRouting ))

SysRequest(388,ScsiTargetDataTransmit,exchNotPresent,0407h,6,1,4,
		( illegal ),
		( noRouting ))

SysRequest(389,CheckScsiTargetCdb,exchNotPresent,0504h,6,0,2,
		( illegal ),
		( noRouting ))

SysRequest(390,WaitScsiTargetCdb,exchNotPresent,0504h,6,0,2,
		( illegal ),
		( noRouting ))

SysRequest(391,GetSerialNumber,exchResex,0D27h,6,0,1,
		( w(12) p0 c(4,22) ),
		( noRouting ))

SysRequest(392,ConfigurationQuery,exchNotPresent,0D28h,6,1,2,
		( illegal ),
		( noRouting ))

SysRequest(393,RemoteCacheGetStatus,exchNotPresent,800Ah,4,1,1,
		( illegal ),
		( noRouting ))


; Requests 394 to 0FDFh are reserved for future expansion by
; Convergent.

Request(1000h,ChangeUserNumISAM,exchISAM,001Ch,2,0,0,
		( w(12) ),
		( noRouting ))

Request(1001h,QuietISAMUser,exchISAM,001Dh,2,0,0,
		( w(12) ),
		( noRouting ))

Request(1002h,QuietContext,exchTerm,0003h,2,0,0,
		( w(12) ),
		( noRouting ))

Request(1003h,QuietQMGR,exchQueMgr,0h,2,0,0,
		( w(12) ),
		( noRouting ))

Request(1004h,QuietSplr,exchSplr,0h,2,0,0,
		( w(12) ),
		( noRouting ))

Request(1005h,Execfh,exchTerm,0005h,4,0,0,
		( w(12) w(14) ),
		( noRouting ))

Request(1006h,InitCommLine,exchCommLine,0300h,6,2,1,
		( pbcb0 pbcb1 pbcb2 ),
		( noRouting ))

Request(1007h,ResetCommLine,exchCommLine,0301h,6,0,0,
		(w(12) ),
		( noRouting ))

Request(1008h,ChangeCommLineBaudRate,exchCommLine,0302h,6,0,0,
		(w(12) w(14) w(16) ),
		( noRouting ))

Request(1009h,TerminateCommLine,exchNotPresent,0000h,2,0,0,
		(w(12) ),
		( noRouting ))

Request(100Ah,ChangeUserNumCommLine,exchNotPresent,0000h,2,0,0,
		(w(12) ),
		( noRouting ))

Request(100Bh,WaitSync,exchNotInstalled,0000h,2,0,0,
		(),
		( noRouting ))

Request(100Ch,NewTapeIO,exchNotInstalled,0000h,6,0,3,
		(),
		( noRouting ))

Request(100Dh,NewTapeIO,exchNotInstalled,0000h,6,1,2,
		(),
		( noRouting ))

Request(100Eh,ReMakeFh,exchFilSys1,000Fh,6,0,1,
		( fh p0 c(2,22) ),
		( rFh ))

Request(100Fh,Sync1,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

Request(1010h,Sync2,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

Request(1011h,Sync3,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

Request(1012h,Sync4,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

Request(1013h,Sync5,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

Request(1014h,Sync6,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

Request(1015h,Sync7,exchNotInstalled,0,2,0,1,
		( w(12) p(14) w(18) ),
		( noRouting ))

Request(1016h,TerminateVideo,exchVideo,0,2,0,0,
		( w(12) ),
		( noRouting ))

Request(1017h,QuietFileSys,exchFilSys3,0FFFFh,2,0,0,
		( w(12) ),
		( noRouting ))

Request(1018h,rqDummy1018,exchNotPresent,00000h,0,0,0,
		( none ),
		( noRouting ))

Request(1019h,GoDebugger,exchNotInstalled,000Eh,6,2,1,
		( w(14) pbcb0 p(24) p(30) c(01,28) c(01,34) )
		( noRouting ))

Request(101Ah,RemoteTermination,exchRemoteTerm,6h,2,0,0,
		(w(12) ),
		( noRouting ))
;

;
;
; NOTES 
; *1 ... Request number 25 (ReadDirSector) field for s2 is a
;        constant 512 (200h).  This is acheived by setting byte
;	 35 of request block to 2,leaving byte 34 as 00h.
; *2 ... Request numbers 63,64,65,66,70,71,72,... are used
;	 internally by CTOS.
;
;
; Request 1 is included only as an example of a user request,and
; is commented out.
;
; (Note that exchanges 0 to 27 are reserved for CTOS processes.)
;
UsrRequestInit
'
'  UsrRequest(1,UserService,exchNotInstalled,0000h,6,1,1,
'  		( w(12) w(16) pbcb0 pbcb1 w(14) ),
'  		( noRouting ))
'
'  where
'
'   1                  is request code (0FFFFh).
'
'   UserService         is the name of the service.  This is 
'                       included here for readability only and
'                       is not actually used for anything.
'
'   exchNotInstalled    is the service exchange.  The exchange
'                       exchNotInstalled goes to the agent at
'                       cluster workstations and is invalid at
'                       the master until the user system service
'                       does a ServeRq request.
'
'   0000H               is the local service code (which the
'                       system service can find out with the
'                       QueryRequestInfo request).
'
'   6                   is the number of bytes of control
'                       information in the request block.  This
'                       is placed at offsets 12, 14, and 16 as
'                       three words by the w()s.
'
'   1                   There is one data buffer sent from
'                       client to service (pbcb0).
'
'   1                   There is one data buffer sent from
'                       service back to client (pbcb1).
'
' There is no routing.  The call to the procedural interface
' would look something like:
'
'   erc := UserService(controlInfo1,controlInfo3,
'                      pbDataToServer, cbDataToServer,
'                      pbBufferRet, sBufferRetMax,
'                      controlInfo2);
'
' The entry in RqLabl.Asm would be:
'
'   RqName(1, UserService)
'
UsrRequest(1,DCCommand,exchNotInstalled,0000h,3,1,1,
		( illegal)  
		( norouting))

UsrRequest(2,DCReport,exchNotInstalled,0000h,2,0,1,
		( illegal) 
		( norouting))

UsrRequest(3,BMCommand,exchNotInstalled,000h,4,1,1,
		( illegal)
		( norouting))

UsrRequest(4,BMReport,exchNotInstalled,000h,2,0,1,
		( illegal)  
		( norouting))

UsrRequest(5,BMQuery,exchNotInstalled,000h,0,0,1,
		( illegal)
		( norouting))

UsrRequest(6,BMClear,exchNotInstalled,000h,2,0,0,
		( none )
		( norouting))

UsrRequest(7,BMPurge,exchNotInstalled,000h,2,0,0,
		( none )
		( norouting))

UsrRequest(8,BMChangeUser,ExchNotInstalled,000h,2,0,0,
		( none)
		( norouting))

UsrRequest(9,QuietBMulti,ExchNotInstalled,000h,2,0,0,
		( none)
		( norouting))

UsrRequest(10,DCReserve,0,000h,0,0,0,
		( illegal) 
		( norouting))

' I added 11 through 17 but have them commented out because we
' do not need them for supporting comm applications.  072289 AT

'UsrRequest(11,LoadKbdxlat,exchLoadKbdxLat,000h,2,0,0,
'		( w(12))
'		( norouting))

'UsrRequest(12,GetKbdID,exchLoadKbdxLat,000h,0,0,1,
'		( p(12) c(2,16))
'		( norouting ))

'UsrRequest(13,ReadMCR,exchLoadKbdxLat,000h,6,0,2,
'		( w(12) p(18) w(22) p(24) c(2,28))
'		( norouting ))

'UsrRequest(14,PurgeMCR,exchLoadKbdxLat,000h,0,0,0,
'		( none )
'		( norouting ))

'UsrRequest(15,FillBufMCR,exchLoadKbdxlat,000h,0,1,0,
'		( w(16) p(12) )
'		( norouting ))

'UsrRequest(16,TerminateMCR,exchLoadKbdxlat,000h,2,0,0,
'		( w(12) )
'		( norouting ))

'UsrRequest(17,LoadKbdXlatFh,exchLoadKbdXlat,000h,2,0,0,
'		( w(12))
'		( norouting ))

' I commented out 18 because I do not understand how it can possibly work.
' It is routed to the same place as  308.  072289 AT

'UsrRequest(18,SetDMAHandler,exchResex,0D80h,10,0,0,
'		( w(12) p(14) w(18) w(20) ),
'		( noRouting ))
EVEN
;
; The list of request codes which the CTOS termination process
; issues to quiet the process activities during subsystem
; termination (invoked with Exit or Chain).  The requests
; are generated with no arguments and with request numbers as
; given to the macro.
;

TerminationRequest(70)			; ResetKbd
TerminationRequest(71)			; ResetSysIn
TerminationRequest(96)			; PurgeISAM
TerminationRequest(108)		; StopEm3270
TerminationRequest(153)        ; CloseAllCommLines
TerminationRequest(164)        ; ResetQueMgr
TerminationRequest(169)        ; PurgeX25User
TerminationRequest(195)		; PurgeTapeUser
TerminationRequest(197)        ; ResetSplr
TerminationRequest(233)        ; TerminateSNAUser
TerminationRequest(239)        ; PurgeMailUser
TerminationRequest(270)		; CtNetTermination
TerminationRequest(273)		; CMTermination
TerminationRequest(274)		; Filter Process Termination
TerminationRequest(1009h)		; TerminateCommLine
TerminationRequest(1016h)		; TerminateVideo
TerminationRequest(6)			; Request code for BMClear
TerminationRequest(16)		; Unlink queued rq blks of a terminating user
EVEN
;
;  The list of request codes which the CTOS master workstation
;  agent or the CtNetServer issues on behalf of cluster workstation
;  when the master or the CtNetServer determines that a cluster
;  workstation is not communicating with it any more.
;

WsAbortRequest(70)			;* ResetKbd
WsAbortRequest(71)			;* ResetSysIn
WsAbortRequest(96)			; PurgeISAM
WsAbortRequest(108)		; StopEm3270
WsAbortRequest(112)		; FileSystemAbort
WsAbortRequest(148)        ; PurgeQueueServer
WsAbortRequest(153)        ; CloseAllCommLines
WsAbortRequest(195)		; PurgeTapeUser
WsAbortRequest(197)        ;* ResetSplr
WsAbortRequest(229)        ; PurgeSNAUser
WsAbortRequest(239)		; PurgeMailUser
WsAbortRequest(251)		; PurgeMailUniqueId
WsAbortRequest(267)        ; PurgeX25
WsAbortRequest(274)		;* Filter Process
WsAbortRequest(7)			; Request code for BMPurge
EVEN
;
;  The list of request codes which a MultiPartitioned CTOS
;  issues on behalf of a system service to notify other system
;  services its user number is changing. These requests are
;  issued when the system service does a ConvertToSys request.
;  The system service's new user number is contained in a word
;  at offset 4 in the request block. The system service's
;  previous user number is contained in a word at offset 12 in
;  the request block.
;  CTOS II does not require ChangeUserNum requests. They are defined
;  here for mixed cluster compatibilty (e.g. CTOS II masterCTOS I cluster).
;

ChgUserNumRequest(218)		; ChangeUserNumQmg
ChgUserNumRequest(219)		; ChangeUserNumFs
ChgUserNumRequest(259)		; ChangeUserNumMail
ChgUserNumRequest(1000h)		; ChangeUserNumISAM
ChgUserNumRequest(100Ah)		; ChangeUserNumComm
ChgUserNumRequest(8)		; ChangeUserNumBMulti
EVEN
;
; The list of request codes which the CTOS termination process
; issues to quiet the process activities before subsystem
; swapout (invoked with SuspendContext).  The requests
; are generated with one argument 'ercSwapping' and with request
; numbers as given to the macro.
; List the requests that cure the most common outstanding requests
; first. Swapping algorithm stops early when there are no more
; outstanding requests, avoiding lengthy requests like
; 'QuietISAMUser' as ISAM is rarely in use.
;

SwappingRequest(265)		; QuietKbdForSwap
SwappingRequest(274)		;* Quiet Filter Process
SwappingRequest(260)		; QuietMailUser
SwappingRequest(1001h)		; QuietISAMUser
SwappingRequest(1003h)		; QuietQMGR
SwappingRequest(1004h)		; QuietSplr
SwappingRequest(1017h)		; QuietFileSys
SwappingRequest(9)		; QuietBMulti


; Final must be invoked after everything else.
Final
END
	( norouting))

UsrRequest(8,BMChangeUser,ExchNotInstalled,000h,2,0,0,
		( none)
		( norouting))

UsrRequest(9,QuietBMulti,ExchNotInstalled,000h,2,0,0,
		( none)
		( norouting))

UsrRequest(10,DCReserve,0,000h,0,0,0,
		( illegal) 
		( noroutin